<?php
//
/**
 *
 * Paypal payment plugin
 *
 * @author Jeremy Magne
 * @version $Id: paypal.php 7217 2013-09-18 13:42:54Z alatak $
 * @package VirtueMart
 * @subpackage payment
 * Copyright (C) 2004-2015 Virtuemart Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.net
 */
defined('_JEXEC') or die();

$lang = JFactory::getLanguage();

/* ====Order info====== */
$order = $viewData['order'];
$order_id = $order['details']['BT']->order_number;
$total_amount = $order['details']['BT']->order_total;

/* ====merchant info====== */
$vnp_Url = $viewData['vnpayurl'];
$secretkey = $viewData['secretkey'];
$tmnCode = $viewData['tmncode'];
$vnpayurlreturn = $viewData['vnpayurlreturn'];
$currency = $viewData['currency'];
$paymenttype = $viewData['paymenttype'];

$date = new DateTime(); //this returns the current date time
$result = $date->format('Y-m-d-H-i-s');
$today = date("Y-m-d H:i:s");
$krr = explode('-', $result);
$result1 = implode("", $krr);
$vnp_Returnurl = JURI::base()."index.php?option=com_virtuemart&view=vmplg&task=pluginresponsereceived";
$hashSecret = $secretkey;
$vnp_Locale = $lang->getTag();
$vnp_OrderInfo = 'Thanh toan don hang luc :' . $today;
$vnp_OrderType = $paymenttype;
$vnp_CurrCode = $currency;
$vnp_TmnCode = $tmnCode;
$vnp_Amount = intval($total_amount * 100);
//$vnp_Amount = 10000*100;
$vnp_IpAddr = $_SERVER['REMOTE_ADDR'];

$Odarray = array(
    "vnp_TmnCode" => $vnp_TmnCode,
    "vnp_Amount" => $vnp_Amount,
    "vnp_Command" => "pay",
    "vnp_CreateDate" => $result1,
    "vnp_CurrCode" => $vnp_CurrCode,
    "vnp_IpAddr" => $vnp_IpAddr,
    "vnp_Locale" => $vnp_Locale,
    "vnp_OrderInfo" => $vnp_OrderInfo,
    "vnp_OrderType" => $vnp_OrderType,
    "vnp_ReturnUrl" => $vnp_Returnurl,
    "vnp_TxnRef" => $order_id,
    "vnp_Version" => "2.1.0",
);

ksort($Odarray);
$query = "";
$i = 0;
$data = "";
foreach ($Odarray as $key => $value) {
    if ($i == 1) {
        $data .= '&' . urlencode($key) . "=" . urlencode($value);
    } else {
        $data .= urlencode($key). "=" . urlencode($value);
        $i = 1;
    }

    $query .= urlencode($key) . "=" . urlencode($value) . '&';
}
$vnp_Url.='?';
$vnp_Url.=$query;
if (isset($hashSecret)) {
    $vnpSecureHash =   hash_hmac('sha512', $data, $hashSecret);
    $vnp_Url .= 'vnp_SecureHash=' . $vnpSecureHash;
}
header('Location: '.$vnp_Url);
die();
?>
